//+------------------------------------------------------------------+
//| This EA should be good for eurusd with default setting.          |
//|                For M5 timeframe only                             |
//|        A new filters has been added                              |
//|          Cycle_KROUFR_version                                    |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "newdigital"
#property link      "http://www.forex-tsd.com"

extern int MagicNumber = 1000;
extern bool EachTickMode = False;
extern double Lots = 0.1;
extern int Slippage = 4;
extern bool StopLossMode = True;
extern int StopLoss = 100;
extern bool TakeProfitMode = True;
extern int TakeProfit = 100;
extern bool TrailingStopMode = True;
extern int TrailingStop = 30;
extern double MaximumRisk       =0;//0.15
extern double DecreaseFactor    =3;
extern int MaxOrders = 3;
extern int PeriodIXO = 15;


#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;
bool TrendUp=false;
bool TrendDown=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   int pipMultiplier=1;
   double StopLossLevel, TakeProfitLevel;

   int digit  = MarketInfo(Symbol(),MODE_DIGITS);
      if (digit==3 || digit==5)
         pipMultiplier=10;

   if (EachTickMode && Bars != BarCount) EachTickMode = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
   
   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+

      double Buy1_1 = iMA(NULL, 0, 21, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
      double Buy1_2 = iMA(NULL, 0, 200, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
      double Buy2_1 = iMA(NULL, 0, 21, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
      double Buy2_2 = iMA(NULL, 0, 200, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
      double Buy3_1 = iSAR(NULL, 0, 0.005, 0.05, Current + 1);
      double Buy3_2 = iSAR(NULL, 0, 0.005, 0.05, Current + 0);
      double Buy4_1 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 1);
      double Buy4_2 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 0);
      double Sell1_1 = iMA(NULL, 0, 21, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
      double Sell1_2 = iMA(NULL, 0, 200, 0, MODE_EMA, PRICE_CLOSE, Current + 1);
      double Sell2_1 = iMA(NULL, 0, 21, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
      double Sell2_2 = iMA(NULL, 0, 200, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
      double Sell3_1 = iSAR(NULL, 0, 0.005, 0.05, Current + 1);
      double Sell3_2 = iSAR(NULL, 0, 0.005, 0.05, Current + 0);
      double Sell4_1 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 1);
      double Sell4_2 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 0);
      double diIXO10=iCustom(NULL,0,"XO_forEA",PeriodIXO,0,0);
      double diIXO21=iCustom(NULL,0,"XO_forEA",PeriodIXO,1,0);
      double d22=(0);
      
      double Kroufr1=iCustom(NULL,PERIOD_H1,"Cycle_KROUFR_version1",12,24,50,true,0,Current + 1);
      double Kroufr0=iCustom(NULL,PERIOD_H1,"Cycle_KROUFR_version1",12,24,50,true,0,Current + 0);
      
      if (Kroufr1 < Kroufr0)
       {
         TrendUp=true;
         TrendDown=false;
       }
      if (Kroufr1 > Kroufr0 )
       {
         TrendUp=false;
         TrendDown=true;
       }
      
      string sComment;
   sComment="";
   sComment=sComment+ "TrendUP="+TrendUp +"\n";
   sComment=sComment+ "TrendDown="+ TrendDown+"\n";
   sComment=sComment+ "Kroufr 1 H1="+Kroufr1 +"\n";
   sComment=sComment+ "Kroufr 0 H1="+Kroufr0 +"\n";
   Comment(sComment);
   
      if (Buy1_1 < Buy1_2 && Buy2_1 >= Buy2_2 && Buy3_1 < Buy3_2 && Buy4_1 < Buy4_2 && diIXO10 > d22 && TrendUp) Order = SIGNAL_BUY;
      if (Sell1_1 > Sell1_2 && Sell2_1 <= Sell2_2 && Sell3_1 > Sell3_2 && Sell4_1 > Sell4_2 && diIXO21< d22 &&TrendDown) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         StopLossLevel = Ask - StopLoss * pipMultiplier * Point;
         TakeProfitLevel = Ask + TakeProfit * pipMultiplier * Point;
         Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), 
                            NormalizeDouble(Ask,digit), 
                            Slippage, 
                            NormalizeDouble(StopLossLevel,digit),  
                            NormalizeDouble(TakeProfitLevel,digit),  
                            "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice()); else Print("Error opening BUY order : ", GetLastError());
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         StopLossLevel = Bid + StopLoss * pipMultiplier * Point;
         TakeProfitLevel = Bid - TakeProfit * pipMultiplier * Point;
         Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), 
                            NormalizeDouble(Bid,digit), 
                            Slippage, 
                            NormalizeDouble(StopLossLevel,digit),  
                            NormalizeDouble(TakeProfitLevel,digit),  
                            "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         
         
         
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice()); else Print("Error opening SELL order : ", GetLastError());
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Check position
   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber ) {
            //Close
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(NormalizeDouble(Bid - OrderOpenPrice(),digit) > NormalizeDouble(Point * TrailingStop * pipMultiplier,digit)) {
                  if(NormalizeDouble(OrderStopLoss(),digit) < NormalizeDouble(Bid - Point * TrailingStop * pipMultiplier,digit)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop * pipMultiplier , OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                  }
               }
            }
         } else {
            if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber)
            {
           
            //Close
            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
               {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
               }
            //Trailing stop
            if (TrailingStopMode && TrailingStop > 0) 
               {                 
               if(NormalizeDouble(OrderOpenPrice() - Ask,digit) > NormalizeDouble(Point * TrailingStop * pipMultiplier,digit)) {
                  if(NormalizeDouble(OrderStopLoss(),digit) > NormalizeDouble(Ask + Point * TrailingStop * pipMultiplier,digit) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop * pipMultiplier , OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                  }
               }
            }
         }}
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
   return(numords);
}  

//bool ExistPositions() {
//	for (int i=0; i<OrdersTotal(); i++) {
//		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
//			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
//				return(True);
//			}
//		} 
//	} 
//	return(false);
//}

double LotsOptimized()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if (MaximumRisk > 0)
   {
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      //----
      if(OrderProfit()>0) break;
      if(OrderProfit()<0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,2);
   }
//--- check min, max and step
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
//---
   return(lot);
}   

//+------------------------------------------------------------------+